package com.ejie.ab79.dao.AB63;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.AB63.Grupos;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableRequestDto;

/**
 * GruposDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class GruposDaoImpl implements GruposDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDGRUPO", "IDTIPOESTABLECIMIENTO", "DESCRIPCIONCASTELLANO",
			"BAJA", "DESCRIPCIONEUSKERA" };

	private JdbcTemplate jdbcTemplate;

	private RowMapper<Grupos> rwMap = new RowMapper<Grupos>() {
		public Grupos mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new Grupos(resultSet.getString("IDGRUPO"), resultSet.getString("IDTIPOESTABLECIMIENTO"),
					resultSet.getString("DESCRIPCIONCASTELLANO"), resultSet.getInt("BAJA"), resultSet.getString("DESCRIPCIONEUSKERA"));
		}
	};

	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	@Transactional(readOnly = true)
	public List<Grupos> findAll(Grupos grupos, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_GRUPO IDGRUPO,t1.ID_TIPO_ESTABLECIMIENTO IDTIPOESTABLECIMIENTO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, "
				+ " t1.BAJA BAJA,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA ");
		query.append("FROM GRUPOS t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(grupos);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, GruposDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	private Map<String, ?> getWhereMap(Grupos grupos) {

		StringBuilder where = new StringBuilder(GruposDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (grupos != null && grupos.getIdGrupo() != null) {
			where.append(" AND t1.ID_GRUPO = ?");
			params.add(grupos.getIdGrupo());
		}
		if (grupos != null && grupos.getIdTipoEstablecimiento() != null) {
			where.append(" AND t1.ID_TIPO_ESTABLECIMIENTO = ?");
			params.add(grupos.getIdTipoEstablecimiento());
		}
		if (grupos != null && grupos.getDescripcionCastellano() != null) {
			where.append(" AND t1.DESCRIPCION_CASTELLANO = ?");
			params.add(grupos.getDescripcionCastellano());
		}
		if (grupos != null && grupos.getBaja() != null) {
			where.append(" AND t1.BAJA = ?");
			params.add(grupos.getBaja());
		}
		if (grupos != null && grupos.getDescripcionEuskera() != null) {
			where.append(" AND t1.DESCRIPCION_EUSKERA = ?");
			params.add(grupos.getDescripcionEuskera());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	public static final int STRING_BUILDER_INIT = 4096;
}
